MONGOIMPORT(1)

NAME
mongoimport - MongoDB Import Utility

SYNOPSIS

The mongoimport tool provides a route to import content from a JSON, CSV, or TSV export created by mongoexport, or potentially, another third-party export tool. See the http://docs.mongodb.org/manual/core/import-export document for a more in depth usage overview, and the mongoexport document for more information regarding mongoexport, which provides the inverse "exporting" capability.

CONSIDERATIONS

Do not use mongoimport and mongoexport for full instance, production backups because they will not reliably capture data type information. Use mongodump and mongorestore as described in http://docs.mongodb.org/manual/core/backups for this kind of functionality.

OPTIONS

mongoimport

mongoimport

--help, -h
    Returns information on mongoimport options and usage.

--verbose, -v
    Increases the amount of internal reporting returned on standard output or in log files. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

--quiet
    Runs mongoimport in a quiet mode that attempts to limit the amount of output. This option suppresses:

•   output from database commands

•   replication activity

•   connection accepted events

•   connection closed events

--version
    Returns the mongoimport release number.

--host <hostname><:port>, -h
    Specifies a resolvable hostname for the mongod to which to connect. By default mongoimport attempts to connect to a MongoDB instance running on the localhost on port number 27017.

    To connect to a replica set, specify the replica set seed name and the seed list of set members. Use the following format:

    <replica_set_name>/<hostname1><:port>,<hostname2:<port>,...

    You can always connect directly to a single MongoDB instance by specifying the host and port number directly.

--port <port>
    Specifies the port number when the MongoDB instance is not running on the standard port of 27017. You may also specify the port number using the --host option.

--ipv6
    Enables IPv6 support, which allows mongoimport to connect to the MongoDB instance using an IPv6 network. All MongoDB programs and processes, including mongoimport, disable IPv6 support by default.

--ssl
    New in version 2.6.

    Enables connection to a mongod or mongos that has SSL support enabled.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCAFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains both the SSL certificate and key. Specify the file name of the .pem file using relative or absolute paths.

    This option is required when using the --ssl option to connect to a mongod or mongos that has sslCAFile enabled without sslWeakCertificateValidation.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslPEMKeyPassword <value>
    New in version 2.6.

    Specifies the password to de-crypt the certificate-key file (i.e. --sslPEMKeyFile). Use --sslPEMKeyPassword only if the certificate-key file is encrypted. In all cases, mongoimport will redact the password from all logging and reporting output.

    If the private key in the PEM file is encrypted and you do not specify --sslPEMKeyPassword, mongoimport will prompt for a passphrase. See ssl-certificate-password.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslCRLFile <filename>
    New in version 2.6.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslAllowInvalidCertificates
    New in version 2.6.

    Bypasses the validation checks for server certificates and allows the use of invalid certificates. When using the sslAllowInvalidCertificates setting, MongoDB logs as a warning the use of the invalid certificate.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--sslFIPSMode
    New in version 2.6.

    Directs mongoimport to use the FIPS mode of the installed OpenSSL library. Your system must have a FIPS compliant OpenSSL library to use --sslFIPSMode.

    The default distribution of MongoDB does not contain support for SSL. For more information on MongoDB and SSL, see http://docs.mongodb.org/manual/tutorial/configure-ssl.

--username <username>, -u
    Specifies a username with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --password and --authenticationDatabase options.

--password <password>, -p
    Specifies a password with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --username and --authenticationDatabase options.

--authenticationDatabase <dbname>
    New in version 2.4.

    Specifies the database that holds the user's credentials. If you do not specify an authentication database, mongoimport assumes that the database specified as the argument to the --db option holds the user's credentials.

--authenticationMechanism <name>
    New in version 2.4.

    Specifies the authentication mechanism. By default, the authentication mechanism is MONGODB-CR, which is the MongoDB challenge/response authentication mechanism. In MongoDB Enterprise, mongoimport also includes support for GSSAPI to handle Kerberos authentication. See http://docs.mongodb.org/manual/tutorial/control-access-to-mongodb-with-kerberos-authentication for more information about Kerberos authentication.

--dbpath <path>
    Specifies the directory of the MongoDB data files. If used, the --dbpath option enables mongoimport to attach directly to local data files without a running mongod. When run with --dbpath, mongoimport locks access to the data directory. No mongod can access the same path while the process runs.

--directoryperdb
    When used in conjunction with the corresponding option in mongod, allows mongoimport to access data from MongoDB instances that use an on-disk format where every database has a distinct directory. This option is only relevant when specifying the --dbpath option.

--journal
    Allows mongoimport operations to use the durability journal to ensure data files remain valid and recoverable. This option is only relevant when specifying the --dbpath option.

--db <database>, -d
    Specifies the name of the database on which to run mongoimport.

--collection <collection>, -c
    Specifies the collection to import.

    New in version 2.6: If you do not specify --collection, mongoimport takes the collection name from the input filename. MongoDB omits the extension of the file from the collection name, if the input file has an extension.

--fields <field1[,field2]>, -f
    Specify a comma separated list of field names when importing csv or tsv files that do not have field names in the first (i.e. header) line of the file.

--fieldFile <filename>
    As an alternative to --fields, the --fieldFile option allows you to specify a file that holds a list of field names if your csv or tsv file does not include field names in the first line of the file (i.e. header). Place one field per line.

--ignoreBlanks
    Ignores empty fields in csv and tsv exports. If not specified, mongoimport creates fields without values in imported documents.

--type <json|csv|tsv>
    Specifies the file type to import. The default format is JSON, but it's possible to import csv and tsv files.

--file <filename>
    Specifies the location and name of a file containing the data to import. If you do not specify a file, mongoimport reads data from standard input (e.g. "stdin").

--drop
    Modifies the import process so that the target instance drops every collection before importing the collection from the input.

--headerline
    If using --type csv or --type tsv, uses the first line as field names. Otherwise, mongoimport will import the first line as a distinct document.

--upsert
    Modifies the import process to update existing objects in the database if they match an imported object, while inserting all other objects.

    If you do not specify a field or fields using the --upsertFields mongoimport will upsert on the basis of the _id field.

--upsertFields <field1[,field2]>
    Specifies a list of fields for the query portion of the upsert. Use this option if the _id fields in the existing documents don't match the field in the document, but another field or field combination can uniquely identify documents as a basis for performing upsert operations.

    To ensure adequate performance, indexes should exist for this field or fields.

--stopOnError
    New in version 2.2.

    Forces mongoimport to halt the import operation at the first error rather than continuing the operation despite errors.

--jsonArray
    Accepts the import of data expressed with multiple MongoDB documents within a single JSON array.

    Used in conjunction with mongoexport --jsonArray to import data written as a single JSON array. Limited to imports of 16 MB or smaller.

USE

In this example, mongoimport imports the csv formatted data in the /opt/backups/contacts.csv into the collection contacts in the users database on the MongoDB instance running on the localhost port numbered 27017.

mongoimport --db users --collection contacts --type csv --file /opt/backups/contacts.csv

Since mongoimport uses the input file name (minus the extension) as the collection name if -c or --collection is unspecified, the following example is equivalent to the previous example:

mongoimport --db users --type csv --file /opt/backups/contacts.csv

In the following example, mongoimport imports the data in the JSON formatted file contacts.json into the collection contacts on the MongoDB instance running on the localhost port number 27017.

mongoimport --collection contacts --file contacts.json

In the next example, mongoimport takes data passed to it on standard input (i.e. with a | pipe.) and imports it into the MongoDB datafiles located at /srv/mongodb/. if the import process encounters an error, the mongoimport will halt because of the --stopOnError option.

mongoimport --db sales --collection contacts --stopOnError --dbpath /srv/mongodb/

In the final example, mongoimport imports data from the file /opt/backups/mdb1-examplenet.json into the collection contacts within the database marketing on a remote MongoDB database. This mongoimport accesses the mongod instance running on the host mongodb1.example.net over port 37017, which requires the username user and the password pass.

mongoimport --host mongodb1.example.net --port 37017 --username user --password pass --collection contacts --db marketing --file /opt/backups/mdb1-examplenet.json

TYPE FIDELITY

WARNING: mongoimport and mongoexport do not reliably preserve all rich BSON data types because JSON can only represent a subset of the types supported by BSON. As a result, data exported or imported with these tools may lose some measure of fidelity. See http://docs.mongodb.org/manual/reference/mongodb-extended-json for more information.

JSON can only represent a subset of the types supported by BSON. To preserve type information, mongoimport accepts strict mode representation for certain types.

For example, to preserve type information for BSON types data_date and data_numberlong during mongoimport, the data should be in strict mode representation, as in the following:

{ "_id" : 1, "volume" : { "$numberLong" : "2980000" }, "date" : { "$date" : "2014-03-13T13:47:42.483-0400" } }

For the data_numberlong type, mongoimport converts into a float during the import.

See http://docs.mongodb.org/manual/reference/mongodb-extended-json for a complete list of these types and the representations used.

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2011-2014, MongoDB, Inc.